zoukankan      html  css  js  c++  java
  • P3065 [USACO12DEC]第一!First!

    题目描述

    Bessie has been playing with strings again. She found that by

    changing the order of the alphabet she could make some strings come before all the others lexicographically (dictionary ordering).

    For instance Bessie found that for the strings "omm", "moo", "mom", and "ommnom" she could make "mom" appear first using the standard alphabet and that she could make "omm" appear first using the alphabet

    "abcdefghijklonmpqrstuvwxyz". However, Bessie couldn't figure out any way to make "moo" or "ommnom" appear first.

    Help Bessie by computing which strings in the input could be

    lexicographically first by rearranging the order of the alphabet. To compute if string X is lexicographically before string Y find the index of the first character in which they differ, j. If no such index exists then X is lexicographically before Y if X is shorter than Y. Otherwise X is lexicographically before Y if X[j] occurs earlier in the alphabet than Y[j].

    Bessie一直在研究字符串。她发现,通过改变字母表的顺序,她可以按改变后的字母表来排列字符串(字典序大小排列)。

    例如,Bessie发现,对于字符串串“omm”,“moo”,“mom”和“ommnom”,她可以使用标准字母表使“mom”排在第一个(即字典序最小),她也可以使用字母表“abcdefghijklonmpqrstuvwxyz”使得“omm”排在第一个。然而,Bessie想不出任何方法(改变字母表顺序)使得“moo”或“ommnom”排在第一个。

    接下来让我们通过重新排列字母表的顺序来计算输入中有哪些字符串可以排在第一个(即字典序最小),从而帮助Bessie。

    要计算字符串X和字符串Y按照重新排列过的字母表顺序来排列的顺序,先找到它们第一个不同的字母X[i]与Y[i],按重排后的字母表顺序比较,若X[i]比Y[i]先,则X的字典序比Y小,即X排在Y前;若没有不同的字母,则比较X与Y长度,若X比Y短,则X的字典序比Y小,即X排在Y前。

    输入输出格式

    输入格式:

    * Line 1: A single line containing N (1 <= N <= 30,000), the number of strings Bessie is playing with.

    * Lines 2..1+N: Each line contains a non-empty string. The total number of characters in all strings will be no more than 300,000. All characters in input will be lowercase characters 'a' through 'z'. Input will contain no duplicate strings.

    第1行:一个数字N(1 <= N <= 30,000),Bessie正在研究的字符串的数量。

    第2~N+1行:每行包含一个非空字符串。所有字符串包含的字符总数不会超过300,000。 输入中的所有字符都是小写字母,即a~z。 输入不包含重复的字符串。

    输出格式:

    * Line 1: A single line containing K, the number of strings that could be lexicographically first.

    * Lines 2..1+K: The (1+i)th line should contain the ith string that could be lexicographically first. Strings should be output in the same order they were given in the input.

    第1行:一个数字K,表示按重排后的字母表顺序排列的字符串有多少可以排在第一个数量。

    第2~K+1行:第i+1行包含第i个按重排后的字母表顺序排列后可以排在第一个的字符串。字符串应该按照它们在输入中的顺序来输出。

    输入输出样例

    输入样例#1: 
    4 
    omm 
    moo 
    mom 
    ommnom 
    
    输出样例#1: 
    2 
    omm 
    mom 
    

    说明

    The example from the problem statement.

    Only "omm" and "mom" can be ordered first.

    样例即是题目描述中的例子,只有“omm”和“mom”在各自特定的字典序下可以被排列在第一个。

    Solution:

      本题trie树+拓扑排序。

      首先,我们不难想到若一个字符串是另一个字符串的前缀,则后者一定不可能排在第一个,那么这种情况直接可以trie树判掉,然后我们可以枚举每个字符串作为第一个串,在trie树中查询该串时对于与当前指针同层次的指针建字符连向字符的有向边并统计入度(表示当前指针所带表字符要比同层次的其它指针表示的字符字典序小),然后就能得到一张图,只要该图无环就说明该字符串可行,需要判环于是想到在该图上跑拓扑排序,若能使每个字符的入度均为0说明可行,否则不行。

    代码:

    #include<bits/stdc++.h>
    #define il inline
    #define ll long long
    #define For(i,a,b) for(int (i)=(a);(i)<=(b);(i)++)
    #define Bor(i,a,b) for(int (i)=(b);(i)>=(a);(i)--)
    using namespace std;
    const int N=27,M=300005;
    int trie[M][26],tot=1;
    int n,ans,to[M],net[M],rd[N],h[N],cnt;
    char s[30005][350];
    bool end[M],ct[M];
    
    il void cler(){cnt=0;memset(h,0,sizeof(h));memset(rd,0,sizeof(rd));}
    
    il void add(int u,int v){to[++cnt]=v,net[cnt]=h[u],h[u]=cnt,rd[v]++;}
    
    il bool bfs(){
        queue<int>q;
        For(i,1,26) if(!rd[i]) q.push(i);
        while(!q.empty()){
            int u=q.front();q.pop();
            for(int i=h[u];i;i=net[i])
                if(--rd[to[i]]==0)q.push(to[i]);
        }
        For(i,1,26) if(rd[i])return 0;
        return 1;
    }
    
    il void insert(char *s){
        int len=strlen(s),p=1,x;
        For(i,0,len-1){
            x=s[i]-'a';
            if(!trie[p][x])trie[p][x]=++tot;
            p=trie[p][x];
        }
        end[p]=1;
    }
    
    il bool search(char *s){
        cler();
        int len=strlen(s),p=1,x;
        For(i,0,len-1){
            x=s[i]-'a';
            if(end[p])return 0;
            For(j,0,25) if(x!=j&&trie[p][j]) add(x+1,j+1);
            p=trie[p][x];
        }
        return 1;
    }
    
    int main(){
        scanf("%d",&n);
        For(i,1,n) scanf("%s",s[i]),insert(s[i]);
        For(i,1,n) if(search(s[i])&&bfs()) ct[i]=1,ans++;
        printf("%d
    ",ans);
        For(i,1,n) if(ct[i]) puts(s[i]);
        return 0;
    }
  • 相关阅读:
    UVA10765图论+点-双连通分量性质应用
    LA4287图论+ 有向图SCC+缩点
    LA5135图论+ 割点性质运用
    LA2572计算几何+离散化+面的覆盖
    LA2402暴力枚举+计算几何+四边形面积
    UVA10566计算几何+相似三角形比例函数+二分范围的辨析
    UVA11300计算几何:正n边形内的最长的线
    UVA11524平面几何+二分法+海伦公式
    LA4986三分法求出凹性函数最小值+计算几何
    胜利大逃亡--hdu --1253(bfs)
  • 原文地址:https://www.cnblogs.com/five20/p/9438396.html
Copyright © 2011-2022 走看看